#include "booster-bpms.h"
#include "bpmplot.h"
#include <qutimearray3dplotplugin_i.h>
#include "ui_booster-bpms.h"

// cumbia
#include <cumbiapool.h>
#include <cuserviceprovider.h>
#include <cumacros.h>
#include <quapps.h>
#include <cupluginloader.h>
// cumbia

#include <QFile>
#include <QGridLayout>
#include <QTextStream>

Boosterbpms::Boosterbpms(CumbiaPool *cumbia_pool, QWidget *parent, const QString &conf, const QString &pos) :
    QWidget(parent)
{
    // cumbia
    CuModuleLoader mloader(cumbia_pool, &m_ctrl_factory_pool, &m_log_impl);
    cu_pool = cumbia_pool;
    ui = new Ui::Boosterbpms;
    ui->setupUi(this, cu_pool, m_ctrl_factory_pool);

    /*
     * CuPluginLoader ploader;
    QObject *pl_obj;
    QuTimeArray3DPlotPlugin_I *pi = ploader.get<QuTimeArray3DPlotPlugin_I>("qutimearray3dplotplugin.so", &pl_obj);
    if(pi) {
        m_surface = pi->create("QuTimeArray3DPlot", 0);
        m_surface->setFlags(m_surface->flags() ^ Qt::FramelessWindowHint);
        m_surface->setProperty("maxNumRows", 1000);
        m_surface->resize(800, 800);
        QWidget *container = QWidget::createWindowContainer(m_surface, centralW);

        // readers from cmd line, if specified, otherwise dummy sin data generator
        for(int i = 1; i < qApp->arguments().size(); i++) {
            QuTimeArrayReader_I *reader = pi->createReader(m_surface, cu_pool, m_ctrl_factory_pool);
            reader->setLink(qApp->arguments()[i], m_surface);
        }
        QSize screenSize = m_surface->screen()->size();
        container->setMinimumSize(QSize(screenSize.width() / 2, screenSize.height() / 1.6));
        container->setMaximumSize(screenSize);
        container->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
        container->setFocusPolicy(Qt::StrongFocus);
        lo->addWidget(container);

        QMenuBar *mb  = menuBar();
        QMenu *m = mb->addMenu("File");
        QAction *showConf = new QAction("Settings", this);
        showConf->setCheckable(true);
        connect(showConf, SIGNAL(toggled(bool)), this, SLOT(showConfiguration(bool)));
        m->addAction(showConf);

        if(qApp->arguments().size()  < 2) {
            m_data_generator = new DataGenerator("Surface 1", this, 1000, 0, 10);
            connect(m_data_generator, SIGNAL(onNewData(QString,double,QVector<double>,QVector<double>)), m_surface,
                    SLOT(addTimeArray(QString,double,QVector<double>,QVector<double>)));
            QAction *addSurface = new QAction("Add surface", this);
            connect(addSurface, SIGNAL(triggered()), this, SLOT(addSurface()));
            m->addAction(addSurface);
        }

        m->addAction("Quit", this, SLOT(close()));
    }
    else
        perr("Qu3DSurfacePluginExample: failed to load plugin: %s", "cu3dsurfaceplugin.so");

     */

    CuPluginLoader pl;
    QObject *pl_obj;
    QuTimeArray3DPlotPlugin_I *pi = pl.get<QuTimeArray3DPlotPlugin_I>("qutimearray3dplotplugin.so", &pl_obj);
    if(!pi) {
        perr("failed to load qutimearray3dplotplugin from %s", qstoc(pl.getPluginPath()));
    }
    // mloader.modules() to get the list of loaded modules
    // cumbia

    QGridLayout *lo = new QGridLayout(this);
    int r = 0, c = 0;
    QFile f(conf);
    if(f.open(QIODevice::ReadOnly|QIODevice::Text)) {
        QTextStream in(&f);
        QString l = in.readLine();
        while(!l.isEmpty()) {
        BpmPlot *p = new BpmPlot(this, cumbia_pool, m_ctrl_factory_pool, pi);
        lo->addWidget(p->widget(), r, c++, 1, 1);
        if(c == 5) {
            c = 0;
            r++;
        }
            l = in.readLine();
        }
        f.close();
    }
}

Boosterbpms::~Boosterbpms()
{
    delete ui;
}
