#include "bpmplot.h"
#include <qutimearray3dplotplugin_i.h>

BpmPlot::BpmPlot(QWidget *parent, CumbiaPool *cp, const CuControlsFactoryPool &fp, QuTimeArray3DPlotPlugin_I *ta3dp)
    : m_p(nullptr), m_surface(nullptr), m_container(nullptr), m_ta3dp(ta3dp), m_cu_p(cp), m_fpool(fp) {
    if(ta3dp)  {
        m_surface = ta3dp->create("QuTimeArray3DPlot", 0);
        m_surface->setFlags(m_surface->flags() ^ Qt::FramelessWindowHint);
        m_surface->setProperty("maxNumRows", 10);
        m_surface->resize(800, 800);
        m_container = QWidget::createWindowContainer(m_surface, parent);
    }
    else
        m_p = new QuSpectrumPlot(parent, cp, fp);
}

QWidget *BpmPlot::widget() {
   return m_container ?  m_container : m_p;
}

void BpmPlot::setSource(const QString &s) {
    QuTimeArrayReader_I *reader = m_ta3dp->createReader(m_surface, m_cu_p, m_fpool);
    reader->setLink(s, m_surface);
}
