#include <quapplication.h>
#include "booster-bpms.h"

// cumbia
#include <cumbiapool.h>
#include <cuthreadfactoryimpl.h>
#include <qthreadseventbridgefactory.h>
// cumbia

#include <QCommandLineOption>
#include <QCommandLineParser>

#define VERSION "1.0"

int main(int argc, char *argv[])
{
    QuApplication qu_app( argc, argv );
    qu_app.setOrganizationName("Elettra");
    qu_app.setApplicationName("Boosterbpms");
    QString version(VERSION);
    qu_app.setApplicationVersion(version);
    qu_app.setProperty("author", "Giacomo");
    qu_app.setProperty("mail", "giacomo.strangolino@elettra.eu");
    qu_app.setProperty("phone", "0403758073");
    qu_app.setProperty("office", "T2PT025");
    qu_app.setProperty("hwReferent", "S.Krecic"); /* name of the referent that provides the device server */

    // $palette$

    CumbiaPool *cu_p = new CumbiaPool();
    QCommandLineParser pa;
    QCommandLineOption cfgfo(QStringList() << "f" << "config-file", "configuration file name", "boobpm.conf");
    QCommandLineOption posh(QStringList() << "H" << "horizontal", "horizontal positions");
    QCommandLineOption posv(QStringList() << "V" << "vertical", "vertical positions");
    pa.addOption(cfgfo);
    pa.addOption(posh);
    pa.addOption(posv);
    pa.process(qu_app);

    Boosterbpms *w = new Boosterbpms(cu_p, nullptr, pa.value(cfgfo), pa.isSet(posh) ? "h" : "v");
    w->show();
    // exec application loop
    int ret = qu_app.exec();
    // delete resources and return
    delete w;

    for(std::string n : cu_p->names())
        if(cu_p->get(n))
            delete cu_p->get(n);

    return ret;
}
